#include <stdio.h>

typedef double ddouble;

typedef ddouble tf(ddouble *y, ddouble x);

typedef tf *ptf;

void euler(ddouble *out, ddouble h, ddouble *y, ddouble x, ptf *f, int num) {
  for (int i = 0; i < num; i ++) {
    out[i] = y[i] + h*(*f[i])(y, x);
  }
}

ptf f[1];

tf f0 {
  return y[0] - x;
}

ddouble y[1];
ddouble x;

void main() {
  f[0] = &f0;
  y[0] = 0;
  x = 0;

  int pockroku = 20;
  double cilovah = 3;
  double h = cilovah / pockroku;

  for (int i = 0; i < pockroku; i ++) {
    euler(y, h, y, x, f, 1);
    x += h;
  }

  printf("%f\n", y[0]);
}